//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <Clipbrd.hpp>
#include "App_MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAppMainForm* AppMainForm = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action11Execute(TObject* ASender)
{
	ProgramCommands->Organize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action11Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = ProgramCommands->CanOrganize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action12Execute(TObject* ASender)
{
	ProgramCommands->Reload();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action12Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = ProgramCommands->CanReload();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action13Execute(TObject* ASender)
{
	ProgramCommands->Start();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action13Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = ProgramCommands->CanStart();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action14Execute(TObject* ASender)
{
	ProgramCommands->Explore();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action14Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = ProgramCommands->CanExplore();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action15Execute(TObject* ASender)
{
	ProgramCommands->ShowProperties();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action15Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = ProgramCommands->CanShowProperties();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action21Execute(TObject* ASender)
{
	DocumentCommands->New();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action21Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanNew();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action221Execute(TObject* ASender)
{
	DocumentCommands->AddRegularFiles();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action221Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanAddRegularFiles();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action222Execute(TObject* ASender)
{
	DocumentCommands->AddDirectory();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action222Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanAddDirectory();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action23Execute(TObject* ASender)
{
	DocumentCommands->Cut();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action23Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanCut();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action24Execute(TObject* ASender)
{
	DocumentCommands->Copy();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action24Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanCopy();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action25Execute(TObject* ASender)
{
	DocumentCommands->Paste();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action25Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanPaste();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action26Execute(TObject* ASender)
{
	DocumentCommands->Delete();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action26Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanDelete();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action27Execute(TObject* ASender)
{
	DocumentCommands->RemoveSucceeded();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action27Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanRemoveSucceeded();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action28Execute(TObject* ASender)
{
	DocumentCommands->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action28Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanSelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action29Execute(TObject* ASender)
{
	DocumentCommands->ReverseSelection();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action29Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanReverseSelection();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A1Execute(TObject* ASender)
{
	DocumentCommands->SortByPath();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A1Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanSortByPath();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2Execute(TObject* ASender)
{
	DocumentCommands->SortByDirectory();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A2Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanSortByDirectory();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A3Execute(TObject* ASender)
{
	DocumentCommands->SortByName();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A3Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanSortByName();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A4Execute(TObject* ASender)
{
	DocumentCommands->SortBySize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A4Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanSortBySize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A5Execute(TObject* ASender)
{
	DocumentCommands->SortByType();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A5Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanSortByType();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A6Execute(TObject* ASender)
{
	DocumentCommands->SortByLastWriteTime();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A6Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanSortByLastWriteTime();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A7Execute(TObject* ASender)
{
	DocumentCommands->SortByResult();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2A7Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanSortByResult();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2BExecute(TObject* ASender)
{
	DocumentCommands->ReverseOrder();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2BUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanReverseOrder();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2CExecute(TObject* ASender)
{
	DocumentCommands->MoveUp();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2CUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanMoveUp();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2DExecute(TObject* ASender)
{
	DocumentCommands->MoveDown();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2DUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanMoveDown();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2EExecute(TObject* ASender)
{
	DocumentCommands->AddFiles(DroppedFiles);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action2EUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = DocumentCommands->CanAddFiles();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action31Execute(TObject* ASender)
{
	OpenCommands->Perform();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action31Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = OpenCommands->CanPerform();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action411Execute(TObject* ASender)
{
	HelpCommands->ShowContents();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action411Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = HelpCommands->CanShowContents();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action412Execute(TObject* ASender)
{
	HelpCommands->ShowAbout();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action412Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = HelpCommands->CanShowAbout();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action51Execute(TObject* ASender)
{
	SettingsModel->Load();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action51Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = SettingsCommands->CanLoad();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action52Execute(TObject* ASender)
{
	SettingsModel->Save();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Action52Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = SettingsCommands->CanSave();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ActionListExecute(TBasicAction* AAction, bool& AHandled)
{
	TCursor LCursor = Screen->Cursor;
	Screen->Cursor = crHourGlass;
	try {
		try {
			if(static_cast<TAction*>(AAction)->Category == "Programs") {
				ActiveControl = ComboBox1;
			}
			else if(static_cast<TAction*>(AAction)->Category == "Documents") {
				ActiveControl = ListView1;
			}
			AAction->OnExecute(AAction);
			AHandled = true;
		}
		catch(...) {
			UpdateNotifier->Invalidate();
			throw;
		}
		UpdateNotifier->Invalidate();
	}
	catch(...) {
		Screen->Cursor = LCursor;
		throw;
	}
	Screen->Cursor = LCursor;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ActionListUpdate(TBasicAction* AAction, bool& AHandled)
{
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ComboBox1Click(TObject* ASender)
{
	UpdateNotifier->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ComboBox1DrawItem(TWinControl* AControl, int AIndex, TRect& ARect, TOwnerDrawState AState)
{
	if(AIndex < 0 || AIndex >= ProgramModel->Count) {
		return;
	}
	TComboBox* LComboBox = static_cast<TComboBox*>(AControl);
	const int LPadding = 1;
	const int LIconSize = 16;

	// Draw the text and the background
	if(AState.Contains(odDisabled)) {
		LComboBox->Canvas->Font->Color = clGrayText;
	}
	LComboBox->Canvas->TextRect(
		ARect,
		ARect.left + LIconSize + LPadding * 3,
		ARect.top + (ARect.Height() - LComboBox->Canvas->TextHeight(LComboBox->Items->Strings[AIndex])) / 2,
		LComboBox->Items->Strings[AIndex]);

	// Draw the icon
	::DrawState(
		LComboBox->Canvas->Handle,
		NULL,
		NULL,
		reinterpret_cast<LPARAM>(ProgramModel->Items[AIndex]->Icon->Handle),
		NULL,
		ARect.left + LPadding,
		ARect.top + (ARect.Height() - LIconSize) / 2,
		LIconSize,
		LIconSize,
		DST_ICON | (AState.Contains(odDisabled) ? DSS_DISABLED : 0));
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	Action21->Execute();
	SaveSettings();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ListView1Change(TObject* ASender, TListItem* AItem, TItemChange AChange)
{
	if(AChange == ctState) {
		UpdateNotifier->Invalidate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ListView1ColumnClick(TObject* ASender, TListColumn* AColumn)
{
	switch(AColumn->Index) {
	case 0:
		Action2A3->Execute();
		break;
	case 1:
		Action2A2->Execute();
		break;
	case 2:
		Action2A4->Execute();
		break;
	case 3:
		Action2A5->Execute();
		break;
	case 4:
		Action2A6->Execute();
		break;
	case 5:
		Action2A7->Execute();
		break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ListView1Data(TObject* ASender, TListItem* AItem)
{
	if(AItem->Index < 0 || AItem->Index >= DocumentModel->Count) {
		return;
	}
	TDocumentEntry* LDocumentEntry = DocumentModel->Items[AItem->Index];
	AItem->Caption = TDocumentDescriber::DescribeByName(LDocumentEntry);
	AItem->SubItems->Add(TDocumentDescriber::DescribeByDirectory(LDocumentEntry));
	AItem->SubItems->Add(TDocumentDescriber::DescribeBySize(LDocumentEntry));
	AItem->SubItems->Add(TDocumentDescriber::DescribeByType(LDocumentEntry));
	AItem->SubItems->Add(TDocumentDescriber::DescribeByLastWriteTime(LDocumentEntry));
	AItem->SubItems->Add(TDocumentDescriber::DescribeByResult(LDocumentEntry));
	AItem->ImageIndex = TDocumentDescriber::DetermineImageIndex(LDocumentEntry);
	AItem->StateIndex = TDocumentDescriber::DetermineStateIndex(LDocumentEntry);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Initialize()
{
	try {
		// Lay out the window correctly
		AutoSize = true;
		AutoSize = false;
		Panel1->Align = alClient;

		TDocumentDescriber::ImageIndex_RegularFile = 0;
		TDocumentDescriber::ImageIndex_Directory = 1;
		TDocumentDescriber::StateIndex_None = 0;
		TDocumentDescriber::StateIndex_Succeeded = 1;
		TDocumentDescriber::StateIndex_Failed = 2;
		FProgramModel = new TProgramModel();
		FProgramModel->OnReload = ProgramModelReload;
		FProgramSelections = new TProgramSelections(FProgramModel, ComboBox1);
		FProgramCommands = new TProgramCommands(FProgramModel, FProgramSelections);
		FDocumentModel = new TDocumentModel();
		FDocumentModel->OnInsertItems = DocumentModelInsertItems;
		FDocumentModel->OnDeleteItems = DocumentModelDeleteItems;
		FDocumentModel->OnClear = DocumentModelClear;
		FDocumentModel->OnReorder = DocumentModelReorder;
		FDocumentModel->OnItemsChange = DocumentModelItemsChange;
		FDocumentSelections = new TDocumentSelections(FDocumentModel, ListView1);
		FDocumentCommands = new TDocumentCommands(FDocumentModel, FDocumentSelections);
		FDocumentCommands->OnChange = DocumentCommandsChange;
		FOpenModel = new TOpenModel();
		FOpenCommands = new TOpenCommands(FProgramModel, FProgramSelections, FDocumentModel, FDocumentSelections, FOpenModel);
		FViewModel = new TViewModel(this, ListView1);
		FViewCommands = new TViewCommands(FViewModel);
		FHelpModel = new THelpModel();
		FHelpCommands = new THelpCommands(FHelpModel);
		FSettingsModel = new TSettingsModel();
		FSettingsCommands = new TSettingsCommands(FSettingsModel);
		FSettingsModel->Register("SettingsCommands", FSettingsCommands);
		FSettingsModel->Register("ProgramCommands", FProgramCommands);
		FSettingsModel->Register("DocumentCommands", FDocumentCommands);
		FSettingsModel->Register("OpenCommands", FOpenCommands);
		FSettingsModel->Register("ViewCommands", FViewCommands);
		FSettingsModel->Register("HelpCommands", FHelpCommands);
		FFileDropWatcher = new TFileDropWatcher(this);
		FFileDropWatcher->Enabled = true;
		FFileDropWatcher->OnFileDrop = FileDropWatcherFileDrop;
		FUpdateNotifier = new TUpdateNotifier();
		FUpdateNotifier->OnUpdate = UpdateNotifierUpdate;

		FProgramModel->Reload();
		LoadSettings();
		FUpdateNotifier->Update();
		::PostMessage(Handle, WM_APP_EXECUTE, 0, 0);
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Uninitialize()
{
	delete FFileDropWatcher;
	FFileDropWatcher = NULL;

	delete FSettingsCommands;
	FSettingsCommands = NULL;

	delete FSettingsModel;
	FSettingsModel = NULL;

	delete FHelpCommands;
	FHelpCommands = NULL;

	delete FHelpModel;
	FHelpModel = NULL;

	delete FViewCommands;
	FViewCommands = NULL;

	delete FViewModel;
	FViewModel = NULL;

	delete FOpenCommands;
	FOpenCommands = NULL;

	delete FOpenModel;
	FOpenModel = NULL;

	delete FDocumentCommands;
	FDocumentCommands = NULL;

	delete FDocumentSelections;
	FDocumentSelections = NULL;

	delete FDocumentModel;
	FDocumentModel = NULL;

	delete FProgramCommands;
	FProgramCommands = NULL;

	delete FProgramSelections;
	FProgramSelections = NULL;

	delete FProgramModel;
	FProgramModel = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HandleCommandLineParameters()
{
	if(ParamCount() == 0) {
		return;
	}
	TStringDynArray LFiles;
	LFiles.Length = ParamCount();
	for(int LI = 0; LI < LFiles.Length; ++LI) {
		LFiles[LI] = ParamStr(LI + 1);
	}
	HandleDroppedFiles(LFiles);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HandleDroppedFiles(const TStringDynArray& AFiles)
{
	try {
		FDroppedFiles = AFiles;
		Action2E->Execute();
	}
	catch(...) {
		FDroppedFiles.Length = 0;
		throw;
	}
	FDroppedFiles.Length = 0;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::UpdateAccess()
{
	for(int LI = 0; LI < ActionList1->ActionCount; ++LI) {
		TAction* LAction = static_cast<TAction*>(ActionList1->Actions[LI]);
		if(LAction->OnUpdate != NULL) {
			LAction->OnUpdate(LAction);
		}
	}
	if(ListView1->SelCount > 0) {
		Label3->Caption = AnsiString().sprintf("%d items are selected", ListView1->SelCount);
	}
	else {
		Label3->Caption = AnsiString().sprintf("%d items", DocumentModel->Count);
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::LoadSettings()
{
	Action51->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::SaveSettings()
{
	Action52->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ProgramModelReload(TObject* ASender)
{
	ProgramSelections->Reload();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::DocumentModelInsertItems(TObject* ASender, const TIntegerDynArray& AIndexes)
{
	DocumentSelections->InsertItems(AIndexes);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::DocumentModelDeleteItems(TObject* ASender, const TIntegerDynArray& AIndexes)
{
	DocumentSelections->DeleteItems(AIndexes);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::DocumentModelClear(TObject* ASender)
{
	DocumentSelections->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::DocumentModelReorder(TObject* ASender, const TReorderRecords& ARecords)
{
	DocumentSelections->Reorder(ARecords);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::DocumentModelItemsChange(TObject* ASender, int AStartIndex, int AEndIndex)
{
	DocumentSelections->ItemsChange(AStartIndex, AEndIndex);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::DocumentCommandsChange(TObject* ASender)
{
	UpdateNotifier->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileDropWatcherFileDrop(TObject* ASender, TDroppedFiles* AFiles, bool& AHandled)
{
	::SetForegroundWindow(Handle);
	TStringDynArray LFiles;
	LFiles.Length = AFiles->Count;
	for(int LI = 0; LI < AFiles->Count; ++LI) {
		LFiles[LI] = AFiles->Files[LI];
	}
	AFiles->Finish();
	AHandled = true;
	HandleDroppedFiles(LFiles);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::UpdateNotifierUpdate(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::WMAppExecute(TMessage& AMessage)
{
	HandleCommandLineParameters();
}
//---------------------------------------------------------------------------
__fastcall TAppMainForm::TAppMainForm(TComponent* AOwner) :
	TForm(AOwner),
	FProgramModel(NULL),
	FProgramSelections(NULL),
	FProgramCommands(NULL),
	FDocumentModel(NULL),
	FDocumentSelections(NULL),
	FDocumentCommands(NULL),
	FOpenModel(NULL),
	FOpenCommands(NULL),
	FViewModel(NULL),
	FViewCommands(NULL),
	FHelpModel(NULL),
	FHelpCommands(NULL),
	FSettingsModel(NULL),
	FSettingsCommands(NULL),
	FDroppedFiles(),
	FFileDropWatcher(NULL),
	FUpdateNotifier(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TAppMainForm::~TAppMainForm()
{
	Uninitialize();
}
//---------------------------------------------------------------------------

