//---------------------------------------------------------------------------
#ifndef App_CommandsH
#define App_CommandsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Inifiles {class TMemIniFile;} using namespace Inifiles;
//---------------------------------------------------------------------------
namespace App_commands {
//---------------------------------------------------------------------------
class ECommandError : public Exception
{
public:
	__fastcall ECommandError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TCommands : public TObject
{
private:
protected:
	static void __fastcall HandleUnavailableFeature();
public:
	__fastcall TCommands();
	virtual __fastcall ~TCommands();
	virtual void __fastcall LoadSettings(TMemIniFile* AValues, const AnsiString& ASection);
	virtual void __fastcall SaveSettings(TMemIniFile* AValues, const AnsiString& ASection);
};
//---------------------------------------------------------------------------
} // End namespace App_commands
using namespace App_commands;
//---------------------------------------------------------------------------
#endif

